#ifdef GL_ES   
    #define LOWP lowp
    precision mediump float;
#else
    #define LOWP
#endif
    
varying LOWP vec4 v_color;
varying vec2 v_texCoords;

uniform sampler2D u_texture;
uniform vec2 u_sizeAtlasTex;
uniform vec2 u_posTex;
uniform vec2 u_sizeTex;
uniform float u_time;
uniform float u_size;
uniform float u_blur;
uniform float u_speed;
uniform float u_frequency;
uniform float u_intensity;


float plot(vec2 st, float pct, float scale){
  return  smoothstep(pct - (u_size + u_blur) * scale, pct - u_size * scale, st.y) - smoothstep(pct + u_size * scale, pct + (u_size + u_blur) * scale, st.y);
}

void main(){

    vec2 uvStartTex = u_posTex.xy / u_sizeAtlasTex.xy;
    vec2 uvSizeTex = u_sizeTex.xy / u_sizeAtlasTex.xy;

    float ratio = uvSizeTex.y / uvSizeTex.x;
    float scaleX = uvSizeTex.x;
    float scaleY = uvSizeTex.y;

    vec2 st = v_texCoords - uvStartTex;

    float time = mod(u_speed * u_time, u_frequency);
    float y = ratio * (-2.5) * (st.x - time * uvSizeTex.x);

    float pct = plot(st, y, scaleY);
    vec3 color = pct * vec3(1.0, 1.0, 1.0);

    vec4 texColor = texture2D(u_texture, v_texCoords);
    texColor.rgb = texColor.rgb + u_intensity * color;

    //gl_FragColor = vec4(color, 1.0);
	gl_FragColor = v_color * texColor;
}