#ifdef GL_ES   
    #define LOWP lowp
    precision mediump float;
#else
    #define LOWP
#endif
    
varying LOWP vec4 v_color;
varying vec2 v_texCoords;

uniform sampler2D u_texture;
//uniform vec2 u_resolution;
uniform vec2 u_sizeAtlasTex;
uniform vec2 u_posTex;
uniform vec2 u_sizeTex;
uniform float u_time;
uniform float u_amplitude;
uniform float u_wavelength;
uniform float u_index;
uniform float u_alpha;

void main(){
	vec2 uvStartTex = u_posTex.xy / u_sizeAtlasTex.xy;
    vec2 uvSizeTex = u_sizeTex.xy / u_sizeAtlasTex.xy;

	float t = v_texCoords.y + (sin(v_texCoords.x * u_wavelength + u_time) * u_amplitude);
	t = (t < uvStartTex.y) ? 1.1 : (t > uvStartTex.y + uvSizeTex.y) ? 1.1 : t;

    //vec2 fragCoord = gl_FragCoord.xy;
	//vec2 uv = fragCoord.xy / u_resolution.xy;

    vec4 color = vec4(1.0, 1.0, 1.0, 1.0);

    color.a = clamp(pow(u_alpha, u_index + 1.0), 0.0, 1.0);
    //color.a = clamp(pow(u_alpha, uv.y * 9.0 + 2), 0.0, 1.0);

    gl_FragColor = color * texture2D(u_texture, vec2(v_texCoords.x, t));
}