#ifdef GL_ES   
    #define LOWP lowp
    precision mediump float;
#else
    #define LOWP
#endif
    
varying LOWP vec4 v_color;
varying vec2 v_texCoords;

uniform sampler2D u_texture;
uniform sampler2D u_noise;

uniform vec2 u_sizeAtlasTex;
uniform vec2 u_posTex;
uniform vec2 u_sizeTex;
uniform vec2 u_sizeAtlasNoise;
uniform vec2 u_posNoise;
uniform vec2 u_sizeNoise;

uniform float u_time;
uniform float u_amplitude;
uniform float u_waveLength;
uniform float u_waveDepth;
uniform float u_offsetY;

void main(){

    vec2 uvStartTex = u_posTex.xy / u_sizeAtlasTex.xy;
	vec2 uvSizeTex = u_sizeTex.xy / u_sizeAtlasTex.xy;

	vec2 uvStartNoise = u_posNoise.xy / u_sizeAtlasNoise.xy;
	vec2 uvSizeNoise = u_sizeNoise.xy / u_sizeAtlasNoise.xy;

	vec2 ratio = uvSizeNoise.xy / uvSizeTex.xy;

    float xTex = v_texCoords.x - uvStartTex.x;
    float yTex = v_texCoords.y - uvStartTex.y;

    vec2 texCoordsNoise = vec2(uvStartNoise.x + xTex * ratio.x, uvStartNoise.y + yTex * ratio.y);

    vec2 displacement = texture2D(u_noise, texCoordsNoise).xy;

    float t = v_texCoords.y + u_offsetY + displacement.y * u_waveDepth + (sin(v_texCoords.x * u_waveLength + u_time) * u_amplitude);
    t = (t < uvStartTex.y) ? 1.1 : (t > uvStartTex.y + uvSizeTex.y) ? (uvStartTex.y + uvSizeTex.y) : t;

    gl_FragColor = v_color * texture2D(u_texture, vec2(v_texCoords.x, t));
}